/*
			ANSI C Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifdef __cplusplus
extern "C" {
#endif

#undef assert
#if defined(__STDC__) || defined(__PROTOTYPES__)
void assert(int);
#endif

#ifdef NDEBUG
# define assert(ignore)
#elif defined(__unix) || defined(unix)
   /* This unix version is very portable and will work with any C library. */
#  include <stdio.h>		/* for stderr */
#  undef assert

#  if defined(__STDC__)
    void abort(void);
#   define assert(value)	((void)((value) || \
	    (fprintf(stderr, \
		"Assertion failed: \"%s\", file %s, line %d\n", #value, \
					__FILE__,__LINE__), abort(),0)))
#  else
#   define assert(value)	((void)((value) || \
	    (fprintf(stderr, "Assertion failed: \"%s\", file %s, line %d\n", \
					"value",__FILE__,__LINE__),exit(1),0)))
#  endif 
#elif defined(__STDC__)		/* This version is compact for embedded */
   int _assert(const char *, const char *, int);
#  define assert(val)	((void)((val)||_assert(#val,__FILE__,__LINE__)))
#else		/* would pass "val" here but that fails if val contains ".  */
#  define assert(val)	((void)((val)||_assert(0,__FILE__,__LINE__)))
#endif 

#ifdef __cplusplus
}
#endif
