/*
		      ANSI C Runtime Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef __GHS_LIMITS_H
#define __GHS_LIMITS_H

#define CHAR_BIT    8
#ifdef __WChar_Is_Short__
#  define MB_LEN_MAX	2
#elif defined(__Long_Is_64) && defined(__WChar_Is_Long__)
#  define MB_LEN_MAX	8
#elif defined(__Int_Is_64) && defined(__WChar_Is_Int__)
#  define MB_LEN_MAX	8
#else
#  define MB_LEN_MAX	4
#endif
#define SCHAR_MIN   (-128)
#define SCHAR_MAX   127
#define UCHAR_MAX   255
#ifdef __Char_Is_Unsigned__
#  define CHAR_MIN    0
#  define CHAR_MAX    UCHAR_MAX
#else
#  define CHAR_MIN    SCHAR_MIN
#  define CHAR_MAX    SCHAR_MAX
#endif
#define SHRT_MIN    (-32768)
#define SHRT_MAX    32767
#define USHRT_MAX   65535
#ifdef __Int_Is_64
#  define INT_MIN     (-0x7fffffffffffffff-1)
#  define INT_MAX     0x7fffffffffffffff
#  define UINT_MAX    0xffffffffffffffffU
#else
#  define INT_MIN     (-2147483647-1)
#  define INT_MAX     2147483647
#  define UINT_MAX    4294967295U
#endif
#ifdef __Long_Is_64
#  define LONG_MIN    (-0x7fffffffffffffffL-1)
#  define LONG_MAX    0x7fffffffffffffffL
#  define ULONG_MAX   0xffffffffffffffffUL
#else
#  define LONG_MIN    (-2147483647L-1)
#  define LONG_MAX    2147483647L
#  define ULONG_MAX   4294967295UL
#endif
#ifndef __STDC__
#  undef UCHAR_MAX
#  define UCHAR_MAX	((unsigned char)255)
#  undef USHRT_MAX
#  define USHRT_MAX	((unsigned short)65535)
#  undef UINT_MAX
#  ifdef __Int_Is_64
#    define UINT_MAX	((unsigned)0xffffffffffffffff)
#  else
#    define UINT_MAX	((unsigned)4294967295)
#  endif
#  undef ULONG_MAX
#  ifdef __Long_Is_64
#    define ULONG_MAX	((unsigned long)0xffffffffffffffff)
#  else
#    define ULONG_MAX	((unsigned long)4294967295)
#  endif
#endif
#ifdef __LL_Is_64
#  define __LL_MIN	(-0x7fffffffffffffffL-1)
#  define __LL_MAX	0x7fffffffffffffffL
#  define __ULL_MAX	0xffffffffffffffffUL
#endif

#ifdef _POSIX_SOURCE
/* macros which depend on pathconf() or sysconf() are optional:
 %define ARG_MAX
 %define CHILD_MAX
 %define LINK_MAX
 %define MAX_CANON
 %define MAX_INPUT
 %define NAME_MAX
 %define OPEN_MAX
 %define PATH_MAX
 %define PIPE_BUF
 %define SSIZE_MAX
 %define STREAM_MAX
 %define TZNAME_MAX
*/
/* POSIX minimum maximums.  System must support this much or more. */
#define NGROUPS_MAX		  16
#define _POSIX_ARG_MAX		4096
#define _POSIX_CHILD_MAX	   6
#define _POSIX_LINK_MAX		   8
#define _POSIX_MAX_CANON	 255
#define _POSIX_MAX_INPUT	 255
#define _POSIX_NAME_MAX		  14
#define _POSIX_NGROUPS_MAX	   0
#define _POSIX_OPEN_MAX		  16
#define _POSIX_PATH_MAX		 255
#define _POSIX_PIPE_BUF		 512
/* added in 1990, don't know the correct values:
%define _POSIX_SSIZE_MAX
%define _POSIX_STREAM_MAX
%define _POSIX_TZNAME_MAX
*/
#endif
#endif	/* _GHS_LIMITS_H */
