/*
		      ANSI C Runtime Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/


#ifndef _SETJMP_H
#define _SETJMP_H
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__NoFloat)
#   if defined(__LL_Is_64)
#	define double long long
#   elif defined(__Long_Is_64)
#	define double long
#   else
#	define double struct { int jmp1, jmp2; }
#   endif
#endif

#if defined(__ns32000)
  typedef int jmp_buf[12];
#elif defined(__i386)
  typedef int jmp_buf[10];	/* SVR3 has 6, Solaris 386 has 10 */
#elif defined(__m68k) && defined(__sun)
  typedef int jmp_buf[58];
#elif defined(__m68k) && defined(__unix)
  typedef int jmp_buf[13];	/* does not save any fp registers */
#elif defined(__m68k)
/*[TPW] Sun Jul 14 02:38:44 PDT 1996.
	In 1.8.8 the size of jmp_buf is now set differently on a per-target
	basis, rather than being a union of all known jmp_buf sizes. However
	the generic 68k jmp_buf was blatantly undersized. It was 25 int's,
	which would have been correct if there were no holes in the jmp_buf
	structure and 68k floating point registers were 64 bits. In reality
	we reserve space for all 16 int reg's and floating point reg's are
	12 bytes long (IEEE extended). So we really need it to be 34 int's.
** Old Code **
  typedef int jmp_buf[25];
** New Code */
  typedef int jmp_buf[34];	/* we save 6 fp registers */
/* End of New Code */
#elif defined(__V800)
  typedef int jmp_buf[18];
#elif defined(__i860)
  typedef double jmp_buf[15];
#elif defined(__m88k)
  typedef int jmp_buf[40];		/* from Unix, we only use 20 ints */
#elif defined(i960) || defined(__i960)
/* MTH Thu Oct 17 10:46:54 PDT 1996  Added jmp_buf_960 for C++ libs */
  typedef struct jmp_buf_960 { double jmp1,jmp2; } jmp_buf[6];	/* was 16 doubles */
#elif defined(alpha) || defined(__alpha)
  typedef double jmp_buf[84];	/* 84 is from OSF, our setjmp only uses 47 */
#elif defined(__clipper)
  typedef int jmp_buf[20];
#elif defined(__FR20)
  typedef int jmp_buf[8];
#elif defined(__gmicro)
  typedef double jmp_buf[32];
#elif defined(__mips) || defined(__nCPU)
  typedef double jmp_buf[32];	/* probably should be 18 doubles */
#elif defined(__ppc)
  typedef double jmp_buf[32];	/* probably should be 24 doubles */
#elif defined(__SH7000)
  typedef int jmp_buf[13];
#elif defined(__sparc)
  typedef int jmp_buf[12];	/* SunOS has 9, Solaris has 12 */
#elif defined(__ARM)
  typedef int jmp_buf[16 /* ints */ + 3 * 8 /* FP regs */];
#elif defined(__Tricore)
  typedef int jmp_buf[18];
#elif defined(__MCORE__)
  typedef int jmp_buf[9];
#else
  typedef double jmp_buf[32];
#endif

#undef double

#if defined(__STDC__) || defined(__PROTOTYPES__)
#define __ARGS(x)		x
#else
#define __ARGS(x)		()
#endif
#ifdef _POSIX_SOURCE
typedef	int sigjmp_buf[(sizeof(jmp_buf)/sizeof(int))+1];
int  sigsetjmp	__ARGS((sigjmp_buf, int));
void siglongjmp	__ARGS((sigjmp_buf, int));
#endif
int  setjmp	__ARGS((jmp_buf));
void longjmp	__ARGS((jmp_buf, int));

#if defined(__STDC__) || defined(__cplusplus)
#define setjmp(env)	(setjmp(env))	    /* Standard says it's a macro */
#endif

#undef __ARGS
#ifdef __cplusplus
}
#endif
#endif
