/*
		      ANSI C Runtime Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef _GHS_ANSI_SIGNAL_H
#define _GHS_ANSI_SIGNAL_H
#ifdef __cplusplus
extern "C" {
#endif

#ifndef _SIG_ATOMIC_T
#define _SIG_ATOMIC_T
typedef int sig_atomic_t;
#endif

#if defined(__STDC__) || defined(__PROTOTYPES__)
#define SIG_DFL 	((void (*) (int)) 0)
#define SIG_IGN 	((void (*) (int)) 1)
#define SIG_ERR 	((void (*) (int)) (-1))
#define __ARGS(x)		x
#else
#define SIG_DFL 	((void (*) ())    0)
#define SIG_IGN 	((void (*) ())    1)
#define SIG_ERR 	((void (*) ()) (-1))
#define __ARGS(x)		()
#endif

void (*signal __ARGS((int, void (*)(int)))) __ARGS((int));
int raise __ARGS((int));

#if defined(_POSIX_SOURCE)
#if defined(__m88k)
typedef struct { unsigned long s[2] } sigset_t;
#else
typedef	int		sigset_t;
#endif
struct sigaction {
	void 		(*sa_handler)();
	sigset_t	sa_mask;
	int		sa_flags;
};
int	kill	__ARGS((int, int));
int sigaction	__ARGS((int, const struct sigaction *, struct sigaction *));
int sigaddset	__ARGS((sigset_t *, int));
int sigdelset	__ARGS((sigset_t *, int));
int sigemptyset	__ARGS((sigset_t *));
int sigfillset	__ARGS((sigset_t *));
int sigismember	__ARGS((sigset_t *, int));
int sigpending	__ARGS((sigset_t *));
int sigprocmask	__ARGS((int, const sigset_t *, sigset_t *));
int sigsuspend	__ARGS((const sigset_t *));
#endif

#define SIGINT		2
#define SIGILL		4
#define SIGABRT 	6
#define SIGFPE		8
#define SIGSEGV 	11
#define SIGTERM 	15

/* standard bsd signals in addition to these */
#define SIGHUP		1
/* SIGINT */
#define SIGQUIT 	3
/* SIGILL */
#define SIGTRAP 	5
#define SIGIOT		SIGABRT
#define SIGEMT		7
/* SIGFPE */
#define SIGKILL 	9
#define SIGBUS		10
/* SIGSEGV */
#define SIGSYS		12
#define SIGPIPE 	13
#define SIGALRM 	14
/* SIGTERM */
#define SIGURG		17
#define SIGSTOP 	18
#define SIGTSTP 	19
#define SIGCONT 	20
#define SIGCHLD 	21
#define SIGCLD		SIGCHLD
#define SIGTTIN 	22
#define SIGTTOU 	23
#define SIGIO		24
#define SIGXCPU 	25
#define SIGXTIM 	26
#define SIGXFSZ 	27
#define SIGVTALRM	28
#define SIGPROF 	29
#define SIGWINCH	30
#define SIGUSR1 	31
#define SIGUSR2 	32

#define _SIGMAX 	SIGUSR2

#undef __ARGS
#ifdef __cplusplus
}
#endif
#endif	/* _GHS_ANSI_SIGNAL_H */

