/*
		   ANSI C/C++ Runtime Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef _STDARG_H
#define _STDARG_H
#ifdef __cplusplus
extern "C" {
  extern int __va_ansiarg;
/* [edlee] Thu Dec 12 23:20:29 PST 1996.  cxxfe now parses __va_align(), so
*  we don't need this define any more.  Old:
*# define __va_align(t)	__ALIGNOF__(t)
* End Old */
#endif

/* ISO requires that va_start and va_end be macros which evaluate to void */
#define va_end(list)  ((void)0)

# if defined(ghs_c_out) || defined(__ghs_c_out)
    /* THIS MUST COME FIRST BECAUSE THE TRANSLATOR WILL DEFINE THE OTHER */
    /*	SYMBOLS AS APPROPRIATE */
    /* Hack to pass stdarg stuff through to the underlying c compiler */
    #define va_list __va_list
    #define va_start(list,lstprm) __va_start(list,lstprm)
    #undef  va_end
    #define va_end(list) __va_end(list)
    #define va_arg(list,mode) __va_arg(list,mode)

# elif defined(__ghs_stdcall)
# if defined (__SoftwareFloat) || defined(__NoFloat)

#  if defined (__FR20)
    /* the FR20 has 4-byte stack alignment, yet doubles are 8-byte aligned
     * relative to the first argument, just like V850 and V830.  eventually,
     * maybe we can use this for all other ghs_stdcall chips.
     */

    /* [jonhsu] Fri Jul 18 09:17:56 PDT 1997
     * Added declarations for to support vargs in C++.
     * New code: */
#ifdef __cplusplus
    int (__va_iargnum)(...);
    extern int *__va_stkarg;
#endif  /* __cplusplus */
    /* End new code */

   typedef struct { char *va_list; int va_stkmod7; } va_list;

/* [jonhsu] Thu Sep 18 17:09:16 PDT 1997 varargs preceded by more than 4 args 
is not being handled correctly. Hopefully, this will correct it.
Old code:
#  define va_start(ap,va_alist) ((ap).va_list= (char *)(&__va_ansiarg + \
	    __va_iargnum(va_alist)), ((ap).va_stkmod7 = (int)__va_stkarg&7) )

New code: */
#  define va_start(ap,va_alist) ((ap).va_list= (char *)(&__va_ansiarg + \
	    (__va_iargnum(va_alist)>4? 4:\
	    __va_iargnum(va_alist))), \
	    ((ap).va_stkmod7 = (int)__va_stkarg&7) )
/* End new code */

#  define va_arg(p, mode) (__va_regtyp(mode) ? \
    /* for non-structs; double must be 8-byte aligned relative to 1st arg */ \
    ((mode *)((p).va_list = (char *) (((int)(p).va_list + \
    (sizeof(mode)>4?(((p).va_stkmod7 !=((int)(p).va_list&7))*4):0)+3)& ~3)+\
	sizeof(mode)))[-1] : \
    /* for a struct, dereference it */ \
    *((mode **)((p).va_list = (char *)((int)(p).va_list+sizeof(mode *))))[-1])

#  else /* not FR20 */
#     ifdef __cplusplus
       extern int __va_intreg;
       int (__va_iargnum)(...);
       int (__va_dargnum)(...);
#     endif /* __cplusplus */

    typedef char *va_list;
/* [Jiong] Wed Nov 13 11:03:08 PST 1996 - support MIPS 64 bit SF varargs.
This is for non-64 bit mode. Moved down in 'ifndef __Reg_is_64'. Add a
new one in #else.
#    define va_start(list,va_alist) list = (char *) (&__va_ansiarg+__va_iargnum(va_alist))
*/
#ifndef __Reg_Is_64
#    define va_start(list,va_alist) list = (char *) (&__va_ansiarg+__va_iargnum(va_alist))
#    define va_arg(list,mode) (__va_regtyp(mode) ? ((mode *)(list =\
	    (char *) ((((int)list + (__va_align(mode)<=4?3:7)) &\
	    (__va_align(mode)<=4?-4:-8))+sizeof(mode))))[-1] : \
	    *((mode **)(list = (char *)((int)list+sizeof(mode *))))[-1])
#else /* 64 bit regs means 8 bytes for all args here */
#    define va_start(list,va_alist) list = (char *)((long long *)&__va_ansiarg+ \
						__va_iargnum(va_alist))
#ifdef __BigEndian
#    define va_arg(list,mode) (__va_regtyp(mode) ? ((mode *)(list =\
	    (char *) ((int)list + 8)))[-1] : \
     /*	the 32 bit pointer to mode is stored in the lower 32 bit word. Old:
            *((mode **)(list = (char *)((int)list+sizeof(mode *))))[-1]) 
     New: */ \
	    *((mode **)(list = (char *)((int)list+8)))[-1])
#else /* __LittleEndian */
#    define va_arg(list,mode) (__va_regtyp(mode) ? ((mode *)(list =\
	(char *) ((((int)list + 7) & -8)+(int)sizeof(mode))))[-1] : \
	*((mode **)(list = (char *)((((int)list+7)&-8)+sizeof(mode *))))[-1])
#endif /* Endian */
#endif /* __Reg_Is_64 */
#endif /* FR20 */

# else /* !defined (__SoftwareFloat) */

#if defined(__mips) && defined(__Reg_Is_64)
     typedef long long __PTYP;
     #define NINTREGS 8
     #define NFLTREGS 8
     /* [Jiong] Wed Mar 31 17:28:39 PST 1999 */
     #define DSIZE    1		/* double occupies one register */
#else
     typedef int __PTYP;
     #define NINTREGS 8
     #define NFLTREGS 4
     #define DSIZE    2		/* double occupies two registers */
#endif

     typedef struct {__PTYP *reg_ptr,int_cnt,FP_cnt,mem_cnt;} va_list;

#ifdef __cplusplus
       int (__va_iargnum)(...);
       int (__va_dargnum)(...);
#endif /* __cplusplus */

#    define va_start(p,va_alist) \
	((p).reg_ptr=(__PTYP *)(&__va_ansiarg), \
	 (p).int_cnt= __va_iargnum(va_alist), \
	 (p).FP_cnt=  __va_dargnum(va_alist), \
	 (p).mem_cnt=(__va_iargnum(va_alist)>NINTREGS? \
			__va_iargnum(va_alist)-NINTREGS : 0) + \
		     (__va_dargnum(va_alist)>NFLTREGS? \
                        (__va_dargnum(va_alist)-NFLTREGS)*DSIZE :0) ) 
#    define va_arg(list,mode) \
	(*(mode *)__gh_va_arg(&list, __va_regtyp(mode), __va_float(mode), sizeof(mode)))
     char *__gh_va_arg(va_list *, int, int, int);

# endif /* !defined (__SoftwareFloat) */

# elif defined(__acp)

    typedef struct {
	 char *va_adr[9];  /* potential addresses of input args*/
	 int	  va_narg;  /* position index in parameter-list */
    } va_list[1];	    /* to do v?printf this must be an array */
				     /* so we can get an implicit pointer */

#    define va_start(ap,va_alist) \
       ( \
	 (ap)[0].va_adr[0] = (char *)&__va_ansiarg, \
	 (ap)[0].va_adr[1] = (char *)&__va_intreg0, \
	 (ap)[0].va_adr[2] = (char *)&__va_dblreg0, \
	 (ap)[0].va_adr[3] = (char *)&__va_intreg1, \
	 (ap)[0].va_adr[4] = (char *)&__va_dblreg1, \
	 (ap)[0].va_adr[5] = (char *)&__va_intreg2, \
	 (ap)[0].va_adr[6] = (char *)&__va_dblreg2, \
	 (ap)[0].va_adr[7] = (char *)&__va_intreg3, \
	 (ap)[0].va_adr[8] = (char *)&__va_dblreg3, \
	 (ap)[0].va_narg = __va_argnum(va_alist)+1 \
    )

#    define va_arg(ap,type) \
       ((ap)[0].va_narg++ < 4 && __va_regtyp(type) ? \
      ((type *)((ap)[0].va_adr[2*(ap)[0].va_narg+__va_align(type)/4-2]))[0]: \
      ( (type *)((ap)[0].va_adr[0]=(char *)(((int)(ap)[0].va_adr[0]+__va_align(type)-1 \
			     & -__va_align(type)) + sizeof(type))))[-1] \
    )


# elif defined(m88k)||defined(__m88k)
    /* This structure must be the same as the structure in varargs.h */
    typedef struct _va_struct {
	    int next_arg;
	    int *mem_ptr;
	    int *reg_ptr;
    } va_list;

#     define va_start(ap,va_alist) ( \
	   (ap).next_arg= (int *)&__va_ansiarg-__va_stkarg,\
	   (ap).mem_ptr=(int*)(((char*)&__va_ansiarg)-(ap).next_arg*4),\
	   (ap).reg_ptr = (int *)__va_intreg)

#     if defined(__LittleEndian)
char *_gh_va_arg(struct _va_struct *, int, int, int);
#    define va_arg(ap,type) \
       (*(type*)_gh_va_arg(&ap,__va_align(type),__va_regtyp(type),sizeof(type)))
#    else
#      define va_arg(p,typ)(*(typ*) \
      ((char*)((((p).next_arg+=((p).next_arg&(__va_align(typ)==8))), \
	       (((p).next_arg+=(sizeof(typ)+3)/4)-(sizeof(typ)+3)/4)+ \
	       ((__va_regtyp(typ)&&(p).next_arg<8)?(p).reg_ptr:(p).mem_ptr)))+\
	       (__va_regtyp(typ)?((sizeof(typ)==1)?3:(sizeof(typ)==2)?2:0):0)))
#    endif

# elif defined(i860) | defined(__i860)
    /*
    Stdarg for the Intel i*860 processor
    */
    typedef struct {
	int va_iarg;
	int va_darg;
	char *va_stkaddr;
	int *va_iregs;
	double *va_dregs;
    } va_list[1];		    /* to do v?printf this must be an array */
				    /* so we can get an implicit pointer */

#     define va_start(ap,va_alist)  ( (ap)[0].va_iarg=__va_iargnum(va_alist), \
				  (ap)[0].va_darg=__va_dargnum(va_alist), \
				    (ap)[0].va_stkaddr= (char*)&__va_ansiarg, \
				    (ap)[0].va_iregs = __va_intreg-1, \
				    (ap)[0].va_dregs = __va_dblreg-1 )

#    define va_arg(ap,type)\
    ( ((__va_regtyp(type)&&sizeof(type)==sizeof(int)&&(ap)[0].va_iarg<12)? \
	(++(ap)[0].va_iarg,*((type*) ((ap)[0].va_iregs+(ap)[0].va_iarg))): \
	(__va_regtyp(type)&&sizeof(type)==sizeof(double)&&(ap)[0].va_darg<4)? \
		    (++(ap)[0].va_darg,*((type*) ((ap)[0].va_dregs+(ap)[0].va_darg))): \
	    (((type *) ((ap)[0].va_stkaddr= \
		((char*) (((int)(ap)[0].va_stkaddr+__va_align(type)-1)&-__va_align(type))) \
		+ sizeof(type)))[-1]) \
    ))
# elif defined(__clipper) | defined(clipper)

    typedef struct {
	 char *va_adr[5];  /* potential addresses of input args*/
	 int	  va_narg;  /* position index in parameter-list */
    } va_list[1];	    /* to do v?printf this must be an array */
				     /* so we can get an implicit pointer */

#    define va_start(ap,va_alist) \
       ( (ap)[0].va_adr[0] = (char *)&__va_ansiarg, \
	 (ap)[0].va_adr[1] = (char *)&__va_intreg0, \
	 (ap)[0].va_adr[2] = (char *)&__va_dblreg0, \
	 (ap)[0].va_adr[3] = (char *)&__va_intreg1, \
	 (ap)[0].va_adr[4] = (char *)&__va_dblreg1, \
	 (ap)[0].va_narg = __va_argnum(va_alist)+1)

#    define va_arg(ap,type) \
       ((ap)[0].va_narg++ < 2 && __va_regtyp(type) ? \
      ((type *)((ap)[0].va_adr[2*(ap)[0].va_narg+__va_align(type)/4-2]))[0]: \
      ( (type *)((ap)[0].va_adr[0]=(char *)(((int)(ap)[0].va_adr[0]+__va_align(type)-1 \
			     & -__va_align(type)) + sizeof(type))))[-1])

# elif defined(ns32000) | defined(__ns32000)
    /*
    Stdarg for the National 32000 processor
    */
    typedef struct {
	    char *va_adr[5];
	    int va_narg;
    } va_list[1];		/* to do v?printf this must be an array */
				/* so we can get an implicit pointer */

#    define va_start(ap,va_alist) \
    (	    (ap)[0].va_adr[0] = (char *)&__va_ansiarg, \
	    (ap)[0].va_adr[1] = (char *)&__va_intreg0, \
	    (ap)[0].va_adr[2] = (char *)&__va_dblreg0, \
	    (ap)[0].va_adr[3] = (char *)&__va_intreg1, \
	    (ap)[0].va_adr[4] = (char *)&__va_dblreg1, \
	    (ap)[0].va_narg = __va_argnum(va_alist)+1)

#    define va_arg(p,typ) \
    ((p)[0].va_narg++ < 2 && __va_regtyp(typ) ? \
      ((typ*)((p)[0].va_adr[2*(p)[0].va_narg+(sizeof(typ))/8-1]))[0]: \
      ((typ*)((p)[0].va_adr[0]=(char*)(((int)(p)[0].va_adr[0]+__va_align(typ)-1\
				& -__va_align(typ)) + sizeof(typ))))[-1])

# elif defined(ppc)  || defined(__ppc)
    typedef struct {int *oflo_ptr,*reg_ptr,int_cnt,FP_cnt,mem_cnt;} gh_va_list;
    typedef struct {char gpr,fpr,pad1,pad2,*overflow_arg_area,*reg_save_area;} va_list[1];
    char *__gh_va_arg(gh_va_list *, int, int, int);
    void *__va_arg(va_list, int);
#     ifdef __cplusplus
       extern int __va_intreg;
       int (__va_iargnum)(...);
       int (__va_dargnum)(...);
#     endif /* __cplusplus */

#if defined(__BigEndian)
#      define va_arg(list,mod) \
       ((sizeof(mod) >= 3) ? /* 3 byte packed structs */ \
	(*(mod*)__va_arg(list,__va_regtyp(mod)?(1+2*__va_float(mod)):0)) : \
        (*(mod*)((char*)__va_arg(list,__va_regtyp(mod)?(1+2*__va_float(mod)):0)\
						       + (4-sizeof(mod)))))
#else /* little endian */
#      define va_arg(list,mod) \
	(*(mod*)__va_arg(list,__va_regtyp(mod)?(1+2*__va_float(mod)):0))
#endif /* #ifdef __BigEndian */

#    define va_start(p,va_alist) \
	((p)->overflow_arg_area=(char *)(&__va_ansiarg), \
	 (p)->reg_save_area=(char *)__va_intreg, \
	 (p)->gpr= __va_iargnum(va_alist), \
	 (p)->fpr=  __va_dargnum(va_alist))
# elif  defined(i960) || defined(__i960)
    /* Like standard case except for va_arg 16 byte stack alignment */

    typedef char *va_list;
#    define va_start(list,lstprm) list = (char *) (&__va_ansiarg)
#    define va_arg(list,mode) ((mode *)(list =\
	    (char *) ((((int)list + (__va_align(mode)<=4?3:\
		(__va_align(mode)<=8?7:15))) & (__va_align(mode)<=4?-4:\
		(__va_align(mode)<=8?-8:-16)))+sizeof(mode))))[-1]

# elif  defined(mips) || defined(__mips) || \
	defined(V810) || defined(__V810) || \
	defined(__nCPU)
    /* Like standard case except for va_arg 8 byte stack alignment */
    typedef char *va_list;
#    define va_start(list,lstprm) list = (char *) (&__va_ansiarg)
#ifndef __Reg_Is_64
#    define va_arg(list,mode) ((mode *)(list =\
	    (char *) ((((int)list + (__va_align(mode)<=4?3:7)) &\
	    (__va_align(mode)<=4?-4:-8))+sizeof(mode))))[-1]
#else /* 64 bit regs means 8 bytes for all args here */
#ifdef __BigEndian
#    define va_arg(list,mode) ((mode *)(list = (__va_regtyp(mode) ?\
	    (char *) ((((int)list + 7) & -8) + 8) : \
	    (char *) ((((int)list + 7) & -8) + (int)sizeof(mode)))))[-1]
#else /* __LittleEndian */
#    define va_arg(list,mode) ((mode *)(list =\
	    (char *) ((((int)list + 7) & -8)+(int)sizeof(mode))))[-1]
#endif /* Endian */
#endif /* __Reg_Is_64 */

# elif defined(V850) || defined(__V850) || defined(V830) || defined(__V830) \
	|| defined(V830R) || defined(__V830R)
#ifdef __cplusplus
    extern int *__va_stkarg;
#endif	/* __cplusplus */
    typedef struct { char *va_list; int va_stkmod7; } va_list;
#   define va_start(ap,lstprm) ((ap).va_list= (char *)&__va_ansiarg, \
				((ap).va_stkmod7 = (int)__va_stkarg&7))

#   define va_arg(p, mode) ((mode *)((p).va_list = (char *)(((int)(p).va_list +\
(__va_align(mode)>4?(((p).va_stkmod7 !=((int)(p).va_list&7))*4):0)+ 3) & ~3) + \
sizeof(mode)))[-1]


# elif defined(alpha) || defined(__alpha)

    typedef struct{char *__va_stkaddr;int __va_pos;}va_list;

#   ifdef __cplusplus
    extern "C" void __va_start(va_list);
#   endif /* __cplusplus */

#   define va_start(ap,dummy) __va_start(ap)
#   define va_arg(ap,mode) (*(((ap).__va_pos+=(sizeof(mode)+7)&~7),(mode *)((ap).__va_stkaddr+(ap).__va_pos-((__va_float(mode)&&(ap).__va_pos<=48)?56:(sizeof(mode)+7)&~7))))

#elif (defined(ARM) || defined(__ARM)) && !(defined(__VXWORKS) && defined(__SoftwareFloat))

#     ifdef __cplusplus
       extern int __va_intreg;
       int (__va_iargnum)(...);
       int (__va_dargnum)(...);
#     endif /* __cplusplus */

    /* Remember to keep varargs.h and stdargs.h synchronized */

    typedef struct __greg_va_struct {
	int va_darg; /* the number of arguments in the fregs so far */
	int va_pos; /* the offset in the stack array */
	char *va_addr; /* the stack array */
    } va_list[1];
    
#define va_start(ap, va_alist) ((ap)[0].va_darg = __va_dargnum(va_alist), \
				(ap)[0].va_pos = 0, \
				(ap)[0].va_addr = (char*)&__va_ansiarg)

#define va_arg(p,mode) ( \
 ((p)[0].va_darg += __va_float(mode) ? 1 : 0), \
 ((p)[0].va_pos += (__va_float(mode) && ((p)[0].va_darg <= 4)) ? \
                   0 : ((sizeof(mode)+3)&~3)), \
 ((mode *)((p)[0].va_addr + \
           ((__va_float(mode) && ((p)[0].va_darg <= 4)) ? \
    /* Code for if it's from a float register */         \
    /* Remember we added one already */                  \
    	      (8 * ((p)[0].va_darg - 5)) : \
    /* Code for if it's in the main stack area */        \
              ((p)[0].va_pos - ((sizeof(mode)+3)&~3)) \
          )) \
 )[0]      \
)

# elif	defined(m68k) || defined(__m68k) || \
	defined(i386) || defined(__i386)  || \
	defined(gmicro) || defined(__gmicro) || \
	defined(vax) || defined(__vax) || \
	defined(sparc) || defined(__sparc) || \
	defined(am29000) || defined(__am29000) || \
	defined(SH7000) || defined(__SH7000) || \
	defined(FR20) || defined(__FR20) || \
	defined(Tricore) || defined(__Tricore) || \
	defined(__MCORE__) || \
	defined(__ST100) || \
	defined(__NDR) || \
	((defined(ARM) || defined(__ARM)) && defined(__VXWORKS) && defined(__SoftwareFloat))

    /*
    Trivial stdarg, assuming no register parameters.  4 byte align the stack 
    */
    typedef char *va_list;
#    define va_start(list,lstprm) list = (char *) (&__va_ansiarg)

#if (defined(sparc) || defined(__sparc)) && defined(__BUILTIN_VA_ARG_INCR)

#   ifdef __cplusplus
    extern "C" int __builtin_va_arg_incr(...);
#   endif /* __cplusplus */

#    define va_arg(list,mode) ((mode *)__builtin_va_arg_incr((mode *)list))[0]

#elif (defined(m68k) || defined(__m68k)) && (__ghs_alignment < 4)

#    define va_arg(list,mode) \
	(*(mode *)((list += ((sizeof(mode)+1) & -2))-((sizeof(mode)+1) & -2)))

#elif defined(FR20) || defined(__FR20)

#    define va_arg(ap,mode) (!__va_regtyp(mode) ? **(mode **)((ap += 4) - 4) :\
    *(mode *)((ap += (((int)sizeof(mode)+3)&~3)) - (((int)sizeof(mode)+3)&~3)))

#elif defined(Tricore) || defined(__Tricore) || defined(__ST100)

#    define va_arg(list,mode) ((list = (char *)list + ((sizeof(mode)+3) & -4)), \
	    (*(mode *)((char *)list - ((sizeof(mode)+3)&-4))))

#elif defined(__MCORE__) || defined(__NDR)

/* Use __va_align to deal with types and structures that are 8-byte aligned.
   Assume list is 4-byte aligned to begin with. */
#    define va_arg(list,mode) ((mode *)(list =\
	    (char *) ((((int)list + (__va_align(mode)<=4?3:7)) &\
	    (__va_align(mode)<=4?-4:-8))+sizeof(mode))))[-1]

#else

#    define va_arg(list,mode) ((mode *)(list =\
	    (char *) ((((int)list + 3) & -4)+ sizeof(mode))))[-1]
/* [JY] experimental version for bigendian char and short, not enabled
* #  define va_arg(list,typ) (*(typ *)((char*)\
*	    (((list)=(((list)+3) & -4)),((((list)+=sizeof(typ))-sizeof(typ))+\
*	      (__va_regtyp(typ)?((sizeof(typ)==1)?3:(sizeof(typ)==2)?2:0):0)))))
*/

#endif

# else
   #error	  Unknown processor, please add a stdargs entry
# endif

#ifdef __cplusplus
    }
#endif
#endif	/* _STDARG_H */
