/*
		      ANSI C Runtime Library

	Copyright (c) 1983-1997 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef _TIME_H
#define _TIME_H
#ifdef __cplusplus
extern "C" {
#endif

#define CLK_TCK     	60		/* should be sysconf(3) for POSIX */
#define CLOCKS_PER_SEC	1000000

#define _TZ_UNKNOWN (-1)

#if defined(__Chorus)
#include <c_types.h>
#else
#if defined(__cplusplus) && !defined(NULL)
#define NULL 0L		/* C++ requires this to be integral, not a pointer */
#elif !defined(NULL)
#define NULL ((void *)0)/* locale.h stddef.h stdio.h stdlib.h string.h time.h */
#endif

#ifndef _SIZE_T
#define _SIZE_T
# if defined(__Ptr_Is_64) && !defined(__Int_Is_64)
typedef unsigned long size_t;
# else
typedef unsigned int size_t;
# endif
#endif	/* _SIZE_T */
#endif	/* defined(__Chorus) */

#ifndef _CLOCK_T
#define _CLOCK_T
typedef long clock_t;	    /* an arithmetric type, so can't be too accurate */
#endif

#if defined(__STDC__)||defined(__cplusplus)|| \
    !defined(__unix) ||defined(__gmicro) || \
    (defined(__mips) && !(defined(SYSTYPE_SYSV)||defined(SYSTEM_FIVE)))
# ifndef _TIME_T
# define _TIME_T
typedef long time_t;	    /* PLUM HALL wants this to be signed */
# endif
#endif

struct tm {
    int tm_sec; 	    /* seconds of the minute, [0,59] */
    int tm_min; 	    /* minutes of the hour, [0,59] */
    int tm_hour;	    /* hour of the day, [0,23] */
    int tm_mday;	    /* day of the month, [1,31] */
    int tm_mon; 	    /* months since Jan, [0,11] */
    int tm_year;	    /* years since 1900 */
    int tm_wday;	    /* days since Sun, [0,6] */
    int tm_yday;	    /* days since Jan 1, [0,365] */
    int tm_isdst;	    /* daylight savings time */
};

#if defined(__STDC__) || defined(__PROTOTYPES__)
#define __ARGS(x)		x
#else
#define __ARGS(x)		()
#endif
clock_t	   clock	__ARGS((void));
#ifdef __NoFloat
# define   difftime(t1,t0) ((t1)-(t0))
#else
  double   difftime	__ARGS((time_t, time_t));
# define   difftime(t1,t0) (((double)(t1))-((double)(t0)))
#endif
time_t	   mktime	__ARGS((struct tm *));
time_t	   time		__ARGS((time_t *));

char *	   asctime	__ARGS((const struct tm *));
char *	   asctime_r	__ARGS((const struct tm *, char *));
char *	   ctime	__ARGS((const time_t *));
char *	   ctime_r	__ARGS((const time_t *, char *));
struct tm *gmtime	__ARGS((const time_t *));
struct tm *gmtime_r	__ARGS((const time_t *, struct tm *));
struct tm *localtime	__ARGS((const time_t *));
struct tm *localtime_r	__ARGS((const time_t *, struct tm *));
size_t	   strftime	__ARGS((char*, size_t, const char*, const struct tm*));

/* Added the following declarations for better System V compatibility	 */
/* These variables are set by tzset(), which exists in libind.a if it is */
/* compiled with -DNEEDTZSET.  Most systems provide tzset() in libc.a	 */
#if __STDC__==0 || defined(_POSIX_SOURCE)
   void  tzset();
   extern long timezone, altzone;
   extern int daylight;
   extern char *tzname[];
#endif
#undef __ARGS
#ifdef __cplusplus
}
#endif
#endif	/* _TIME_H */
