/***  You should not be explicitly including this file.  ***/

/* yvals.h values header for Green Hills C/C++ */

#ifndef _YVALS
#define _YVALS

#if defined(__ghs) && defined(__NO_STD_USING_DIRECTIVES)
 #define _NO_STD_USING_DIRECTIVES	1
#else
 #define _NO_STD_USING_DIRECTIVES	0
#endif

#if defined(__ghs) && defined(__EXCEPTION_HANDLING)
 #define _HAS_EXCEPTIONS	1
#else	/* __ghs, __EXCEPTION_HANDLING */
 #define _HAS_EXCEPTIONS	0
#endif  /* __ghs, __EXCEPTION_HANDLING */

#if defined(__ghs) && defined(__NAMESPACES) && !defined(__EMBEDDED_CXX_HEADERS)
 #define _HAS_NAMESPACE	1
#else	/* __ghs, __NAMESPACES */
 #define _HAS_NAMESPACE	0
#endif  /* __ghs, __NAMESPACES */

		/* NAMESPACE */
 #if defined(ghs) && _HAS_NAMESPACE
 #if defined(__cplusplus)
  #define _STD			std::
  #define _STD_BEGIN	namespace std {
#if defined(__ghs)
  #define _STD_END		}
#else	/* __ghs */
  #define _STD_END		};
#endif	/* __ghs */
  #define _STD_USING
 #else
  #define _STD			::
  #define _STD_BEGIN
  #define _STD_END
 #endif /* __cplusplus */
 #else	/* _HAS_NAMESPACE */
  #define _STD                  ::
  #define _STD_BEGIN
  #define _STD_END
 #endif /* _HAS_NAMESPACE */

_STD_BEGIN
#pragma ghs startdata
		/* TYPE bool */
 #if defined(__cplusplus)
   #if defined(__ghs) && defined(_BOOL)
     typedef bool _Bool;
   #else	/* __ghs, _BOOL */
     typedef char _Bool;
   #endif /* __ghs, _BOOL */
 #endif /* __cplusplus */
		/* INTEGER PROPERTIES */
#define _MAX_EXP_DIG	8	/* for parsing numerics */
#define _MAX_INT_DIG	32
#define _MAX_SIG_DIG	36
		/* STDIO PROPERTIES */
#if defined(__ghs) && defined(__Chorus) 
# define _Filet	__sFILE
# define _IOBASE _bf._base
# define _IOPTR	_p
# define _IOCNT	_bf._size
/* [TRZ] Wed Aug 26 09:14:24 1998 */
/* New Code */
# define _IORCNT _r
# define _IOWCNT _w
/* End New Code */
#elif defined(__ghs) && defined(__sun) && (defined(__sysV4) || defined(SUNOS))
/* Solaris native */
# define __SOLARIS
# define _Filet	FILE
# define _IOBASE	_base
# define _IOPTR	_ptr
# define _IOCNT	_cnt
/* [TRZ] Wed Aug 26 09:14:24 1998 */
/* New Code */
# define _IORCNT _IOCNT
# define _IOWCNT _IOCNT
/* End New Code */
#elif defined(__ghs) && defined(__VXWORKS)
/* vxWorks */
# define _Filet	__sFILE
# define _IOBASE _bf._base
# define _IOPTR	_p
# define _IOCNT	_bf._size
/* [TRZ] Wed Aug 26 09:14:24 1998 */
/* New Code */
# define _IORCNT _r
# define _IOWCNT _w
/* End New Code */
#elif defined(__ghs) && defined(_WIN32)
# define _Filet	_iobuf
# define _IOBASE	_base
# define _IOPTR	_ptr
# define _IOCNT	_cnt
# define _IORCNT _IOCNT
# define _IOWCNT _IOCNT
#else
# define _Filet	iobuf
# define _IOBASE	io_base
# define _IOPTR	io_next
# define _IOCNT	io_left
/* [TRZ] Wed Aug 26 09:14:24 1998 */
/* New Code */
# define _IORCNT _IOCNT
# define _IOWCNT _IOCNT
/* End New Code */
#endif	/* conditional STDIO PROPERTIES section */
/* [Duane] Wed Sep 16 14:55:07 PDT 1998
 * Let Windows header files define _FPOSOFF
 */
#if !defined(_WIN32)
#define _FPOSOFF(fp)	((long)(fp))
#endif
		/* end STDIO PROPERTIES */

		/* NAMING PROPERTIES */
 #if defined(__cplusplus)
  #define _C_LIB_DECL extern "C" {
  #define _END_C_LIB_DECL }
 #else
  #define _C_LIB_DECL
  #define _END_C_LIB_DECL
 #endif /* __cplusplus */
#define _CDECL
#define _CRTIMP
 #if defined(__cplusplus)
		// LOCK MACROS
#if defined(__ghs) && (defined(__Chorus) || defined(__VXWORKS) || 1)
    #define _LOCK_LOCALE	0
    #define _LOCK_MALLOC	1
    #define _LOCK_STREAM	2
#else /* !__Chorus && !__VXWORKS */

#define _LOCK_LOCALE	0
#define _LOCK_MALLOC	0
#define _LOCK_STREAM	0

#endif /* __Chorus || __VXWORKS */

		// CLASS _Lockit

#if defined(__ghs) && defined(__VXWORKS)

_STD_END
#include <vxWorks.h>
#include <semLib.h>
_STD_BEGIN

class _Lockit {
private:
    static SEM_ID theLock[3];
    int lock_num;
    static int is_init;
public:
    explicit _Lockit(int i);
    ~_Lockit();
    static void InitLocks ();
};


#else /* !__VXWORKS */

#if 1
extern "C" void __ghsLockCpp(int);
extern "C" void __ghsUnlockCpp(int);

class _Lockit {
private:
	int lock_num;
public:
	explicit _Lockit(int i) : lock_num(i) {
		__ghsLockCpp(i);
	}
	~_Lockit() {
		__ghsUnlockCpp(lock_num);
	}
};


#else /* 1 */

class _Lockit
	{	// lock while object in existence
public:
	explicit _Lockit(int = 0)
		{}	// DUMMY -- turn on lock here
	~_Lockit()
		{}	// DUMMY -- turn off lock here
	};

#endif /* 0 */
	
#endif	/* __ghs, __Chorus */

 #endif /* __cplusplus */
		/* MISCELLANEOUS MACROS */
#define _ATEXIT_T	void
#define _Mbstinit(x)	mbstate_t x = {0}
#define _TEMPLATE_STAT

#pragma ghs enddata
_STD_END

#if defined(__ghs) && defined(__EDG_IMPLICIT_USING_STD) && _HAS_NAMESPACE
using namespace std;
#endif	/* __ghs, __EDG_IMPLICIT_USING_STD */

#endif /* _YVALS */

/*
 * Copyright (c) 1996 by P.J. Plauger.  ALL RIGHTS RESERVED. 
 * Consult your license regarding permissions and restrictions.
V2.1:0315 */
