#include <stdio.h>

/**********************************************************************
function:	fgets(s, n, fp)
summary:	routine to get a line from input
description:
	Gets up to n-1 chars from the next line of the input stream fp
	into the char array s.
	Returns a pointer to the char array, or a null pointer if
	at end of file or if an error is encountered
**********************************************************************/
char *fgets(char *s, int n, FILE *fp)
{
	int i, c;
	for(i=0; i<(n-1); ) {
		c=getc(fp);
		if(c==EOF) break;
		s[i++]=c;
		if(c=='\n') break;
	}
	s[i]='\0';
	return (c==EOF && i==0) ? NULL : s;
}
