#include "q.h"


template <class Type>
QueueItem<Type>::QueueItem(const Type& t):item(t)
{
  next = 0;
}


template <class Type>
Queue<Type>::Queue()
{
  front = back = 0;
}

template <class Type>
Queue<Type>::~Queue()
{
  while (is_empty() == 0 )
    (void) remove();
}

template <class Type>
void Queue<Type>::add(const Type &val)
{
  // allocate a new QueueItem object
  QueueItem<Type> *pt = new QueueItem<Type>( val );
  if ( is_empty() )
    front = back = pt;
  else {
    back->next = pt;
    back = pt;
  }
}

template <class Type>
Type Queue<Type>::remove()
{
  if (is_empty()) {
    cerr << "remove() on empty queue.\n";
    exit(-1);
  }
  QueueItem<Type> *pt = front;
  front = front->next;
  Type retval = pt->item;
  delete pt;
  return retval;
}

template <class Type>
char Queue<Type>::is_empty() 
{
  return front == 0 ? 1 : 0;
}

template <class Type>
ostream& operator<<(ostream& os, Queue<Type>& q)
{
  os << "< ";
  QueueItem<Type> *p;
  for (p=q.front; p; p=p->next)
    os << *p << " ";
  os << " >";
  return os;
}

template <class Type>
ostream& operator<<(ostream& os, QueueItem<Type>& qi)
{
  os << qi.item;
  return os;
}

