:
# [JY] This is the official 1.8.9 version of install.sh
# Usage
#	cd /usr/green		# the final installation location
#	tar xvf /dev/rmt 
#	./install.sh
# This script uses Bourne shell syntax.  
# It is intended to work on System V and Bsd systems with any sh or ksh
#---------------------------------------------------------------------- 
if [ -f makefile.get ] ; then
    echo "You are not allowed to install in a ship directory"
    exit 1
fi
#
# Don't allow install.sh to be run on locked products
if [ -f update -a ! -f config.lck -a ! -f ghs_elmd ] ; then
    echo "Your Green Hills Software products must be unlocked before they can"
    echo "be installed."
    echo " "
    echo "Please run the 'update' program as directed by the UPDATE"
    echo "INSTRUCTION SHEET, which is a paper document included with your"
    echo "product shipment.  After this step, the products should be"
    echo "unlocked and ready for installation with install.sh."
    exit 1
fi
#
#---------------------------------------------------------------------- 
CHMOD_D="chmod 755"	# for directories			drwxr-xr-x
CHMOD_X="chmod 755"	# for executables			-r-xr-xr-x
#---------------------------------------------------------------------- 
# determine how to suppress newline on echo command
n='' c='\c' ; export n c
(echo "hi there\c" ; echo " ") >.echotmp
if grep c .echotmp >/dev/null 2>&1 ; then n='-n' c='' ; fi
rm -f .echotmp

#---------------------------------------------------------------------- 
# Unload the files directly onto the machine in their final location.
#
# We need to know the name of this directory.  pwd may not return a pathname 
# which can be used with NFS because the file system is mounted differently
# Give the user a chance to change the default directory and then make sure
# that the new pathname is absolute and that it points to this directory.
TOP=`pwd`
ANS=''
while [ "$TOP" != "$ANS" ] ; do
    echo Enter an absolute pathname for the current directory or press return to use
    echo $n "${TOP}: $c"
    read ANS
    case $ANS in
    ""|y|Y|yes|YES)	ANS=$TOP		;;
    /*)
			touch install.$$
			if [ -d $ANS ] && cd $ANS && [ -f install.$$ ] ; then
			    rm -f install.$$
			    TOP=$ANS
			else
			    echo " "
			    echo $ANS is not a path for $TOP
			    echo " "
			    cd $TOP
			fi
			;;
    *)			echo $ANS does not begin with /
			ANS=""
			;;
    esac
done
		
#---------------------------------------------------------------------- 
# Sort out files in top level.  Don't copy Compilers, source files, to /usr/bin
# Create scripts for *multi* and drivers and copy the scripts to /usr/bin,
# but copy the actual assembler, linker, and librarian to /usr/bin
# [JY] Fri Jan 17 12:12:49 PST 1997.  blank these lists before the loop!
: SCRIPTS="" TOOLS="" VBLDFILES="" BLDFILES=""
for f in `echo *` ; do
    if [ -f $f ] ; then
	case $f in
	vxw*.bld)				VBLDFILES="$VBLDFILES $f" ;;
	*.bld)					BLDFILES="$BLDFILES $f" ;;
	*.*|*akefile*|*readme*)			;;
	acom*|ccom*|cxcom*|fcom*|pcom*)		;;
	dbtest|monserv|cxpatch|reload|update|lm);;
	acpp|cfront|ptcomp|ptlink|patch|munch)	;;
	cxxfe|cxxmunch|decode|prelink)		;;
	elf*|coff*|cref68|dump68|oadmp|oas695|symfmt)	;;
	gcc*|gcx*|gcf*|gfc*|gpc*|gac*|galx*|\
	ghcc|ghcx|ghcf|ghfc|ghpc|\
	cc??*|cf??*|cx??*|fc??*|pc??*|ac??*|alx??*)
			TOOLS="$TOOLS $f" DRIVERSCRIPTS="$DRIVERSCRIPTS $f" ;;
	adamulti|multi)
			MULTI="$MULTI $f"	;;
	*)		TOOLS="$TOOLS $f"
			if [ -f $f.bin ]; then SCRIPTS="$SCRIPTS $f"; fi ;;
	esac
    fi
done
if [ ! "$TOOLS" ] ; then
    echo Fatal Error.  No executable commands to install
    exit 2
fi

if [ "$DRIVERSCRIPTS" ] ; then
    for f in $DRIVERSCRIPTS ; do
# On some hosts the build scripts must begin with #!/bin/sh instead of :
	if [ "$EXEC" != echo ] ; then
	    echo '#!/bin/sh' > $f.tmp
	    echo ghsdir=$TOP/ >> $f.tmp
	    grep -v 'ghsdir=' $f >> $f.tmp
	fi
	$EXEC rm -f $f
	$EXEC mv $f.tmp $f
	$EXEC $CHMOD_X $f
    done
fi
# Create a target.def file, using the alphabetically first candidate .bld
if [ "$MULTI" ] ; then
    if [ "$VBLDFILES" ] ; then BLDFILES="$VBLDFILES $BLDFILES" ; fi
    if [ ! -f target.def -a "$BLDFILES" ] ; then
	for f in $BLDFILES ; do
	    target=`basename $f .bld`
	    if grep :target=$target $f > /dev/null ; then
		echo $target > target.def
		break
	    fi
	done
    fi
fi

#
# possibly copy executables into /usr/bin
if [ "" ] ; then
    echo " "
    echo "The following files are now in $TOP:"
    echo " "
    ls -C $TOOLS $MULTI
    echo " "
    blocks=`ls -s $TOOLS | awk '{ n += $1 ; print n }' | tail -1`
    echo "To use them you will either have to add $TOP"
    echo "to your execution path or copy them to /usr/bin ($blocks blocks)"
    ANS='?'
    while [ "$ANS" = '?' ] ; do
	echo " "
	echo $n "Press <return> to copy files to /usr/bin, or 'n' to skip: $c"
	read ANS
	case $ANS in
	""|y*|Y*)	 for f in $TOOLS ; do
			    if [ -f /usr/bin/$f ] ; then
				if cmp -s $f /usr/bin/$f ; then 
				    :
				else 
				    echo /usr/bin/$f exists. Remove it\?
				    $EXEC rm -i /usr/bin/$f
				fi
			    fi
			    if [ ! -f /usr/bin/$f ] ; then
				$EXEC cp $f /usr/bin/$f
				$EXEC $CHMOD_X /usr/bin/$f
			    fi
			done
		    # create a multi script in /usr/bin, but not in /usr/green
			if [ "$MULTI" ] ; then
			    for f in $MULTI ; do
				if [ -f /usr/bin/$f ] ; then
				    echo /usr/bin/$f exists. Remove it\?
				    $EXEC rm -i /usr/bin/$f
				fi
				if [ ! -f /usr/bin/$f ] ; then
				    if [ "$EXEC" != echo ] ; then
					echo '#!/bin/sh' > /usr/bin/$f
				    echo exec $TOP/$f.bin '"$@"' >> /usr/bin/$f
				    fi
				    $EXEC $CHMOD_X /usr/bin/$f
				fi
			    done
			fi
			THISBIN=/usr/bin ;;
	n*|N*)	THISBIN=$TOP ;;
	*)		ANS='?' ;;
	esac
    done
    echo " "
fi

# Fri Oct 18 16:11:51 PDT 1996
# [MTH] Temporary hack until the builder is fixed such that 
# :alternate_tools_dir takes a path that is relative to the
# .bld file directory.  Jeff is going to make this happen soon.
if [ -f chorus68.bld ] ; then
    echo "	:alternate_tools_dir=`pwd`/gnutools/m68k-sun-sunos4/bin" \
								>> chorus68.bld
fi

# [JAG] install the Ada95 library
if [ -d adalib ] ; then
    cd adalib  
    ../adainst
    cd ..
fi

PATH=$THISBIN:$PATH; export PATH
if [ -f config.lck ] && grep "licenses:" config.lck > /dev/null ; then
    echo Starting a license manager...
    lm
    sleep 5
fi

foo=`echo *.tst`
if [ "$foo" != '*.tst' ]; then
    echo Perform delivery tests.  Each test should print \'Test passed.\'
    for f in *.tst ; do
	echo " "
	echo Delivery test: $f
	sh $f
    done
fi

# We can easily check if anyone on this system is running csh.
if [ "$THISBIN" = /usr/bin -a -f /etc/passwd ] && grep -s csh /etc/passwd ;then
    echo " "
    echo "Note: If you are running the C Shell, csh, you may need to type"
    echo '      "rehash" before the new programs that have just been '
    echo "      installed will be recognized."
fi
echo " "
echo Installation completed.
