/*
		    Low Level Interface Library

            Copyright 1983-1996 Green Hills Software,Inc.

 *  This program is the property of Green Hills Software, Inc,
 *  its contents are proprietary information and no part of it
 *  is to be disclosed to anyone except employees of Green Hills
 *  Software, Inc., or as agreed in writing signed by the President
 *  of Green Hills Software, Inc.
*/

#include "indos.h"
#include <signal.h>

#if defined(EMBEDDED)
/* __ualarmhandler is an interrupt procedure for dispatching alarms */
#if defined(ARM_INTVEC)
#pragma  intvect __ualarmhandler 0x18
#endif
void __ualarmhandler(void) {
#if not defined(ARM_INTVEC) && not defined(THUMB) 
#pragma ghs interrupt
#endif
raise(SIGALRM);
}

/******************************************************************************/
/*  unsigned int ualarm(unsigned int value, unsigned int interval);           */
/*  ualarm arranges for a SIGALRM to be delivered in _value_ microseconds and */
/*  then every _interval_ microseconds thereafter, like the BSD ualarm() call.*/
/*  If the environment does not support this facility, return ~0L.            */
/*									      */
/*  WARNING: _interval_ is not supported at this time and is ignored.         */
/******************************************************************************/

unsigned int ualarm(unsigned int value, unsigned int interval) {
    (void) __ghs_syscall(SYSCALL_HANDLER, __ualarmhandler);
    return __ghs_syscall(SYSCALL_TIMEOUT, value);
    return ~0L;
}

/******************************************************************************/
/*  unsigned int alarm(unsigned int seconds);				      */
/*  ualarm arranges for a SIGALRM to be delivered in _seconds_ seconds.       */
/*  If the environment does not support this facility, return ~0.             */
/******************************************************************************/
unsigned int alarm(unsigned int seconds) {
    return ualarm(seconds*1000000, 0);
}
#else
int alarm_empty_file_is_illegal;
#endif /* defined(EMBEDDED) */
