#include <stdlib.h>
typedef void (*vfpt)();
extern vfpt _ctors[], _dtors[];
 
void __call_dtors(void);


/* Initialize the static constructors using the _ctors array. Set up the call
   to __call_dtors at the exit */
extern "C" void _main()
{
    int i = 0;
    static int been_here = 0;

    if (been_here)
	return;
    been_here = 1;
    
    atexit(__call_dtors);
    while (_ctors[i])
        (*_ctors[i++])();
}

#ifndef __INTEGRITY_SHARED_LIBS
/* [nikola] Fri Oct  9 16:05:18 PDT 1998 - split this into two modules for
 * INTEGRITY shared libraries. This is b/c _ctors[] array should not be part
 * of the shared library (so neither should _main()). 
 * __record_needed_destruction() and __call_dtors() however, have to be part
 * of the library, so it can link.
 *
 * The module ind_dtors.cc has the code below for INTEGRITY
 */


/* the following code is all for supporting destructors.  If no destructors
   exist in the application, it can all be deleted.  If exception_handling
   is enabled in the library , a stub for __call_dtors will still be needed.

   The function, __record_needed_destruction() is called from constructor
   routines generated by cxxfe.  If it is called, it indicates that there
   are some global objects which require destruction.
*/
#ifdef NO_DESTRUCTOR_SUPPORT

void __call_dtors() {}
extern "C" void __record_needed_destruction(node_type node) { }

#else
typedef struct node_type {
    struct node_type *next;
    void	*object;
    vfpt	routine;
} node_type;
typedef void (*dfpt)(void*, int);
    
static node_type *list_head;

/* Note that __call_dtors is not static.  It is called from ____ when 
   exception handling is enabled in the library .  In that case, this 
   function will be called twice, which is okay.
*/
void __call_dtors()
{
    node_type *vfptr;
/*
    This code should not be needed, since cxxfe never creates destructor
    functions recognizable by cxxmunch.  Instead the constructor functions
    for each object insert a node in the linked list, which is processed 
    at the end of this function.
*
    static int been_here = 0;

    if (!been_here) {
	int i = 0;

	been_here = 1;
	while (_dtors[i])
	    i++;
	while (i > 0)
	    (*_dtors[--i])();
    }
*/

    while (list_head) {
	void *objectp;

	vfptr = list_head;
	list_head = list_head->next;
	objectp = vfptr->object;
	if (objectp) {
	    dfpt dfptr = (dfpt)vfptr->routine;
	    (dfptr)(objectp, 2);  /* 2 means destruct, but don't destroy*/
	} else {
	    (vfptr->routine)();
	}
    }
}

extern "C" void __record_needed_destruction(node_type *node)
{
  if (node->next != NULL || node == list_head) 
      return;
  node->next = list_head;
  list_head = node;
}
#endif

#endif /* !__INTEGRITY_SHARED_LIBS */

