/*
		    ANSI C Runtime Library
	
	Copyright 1983-1996 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#if defined(EMBEDDED)

#include <string.h>

/* [jonhsu] Thu Sep 24 17:21:15 PDT 1998  If sizeof(size_t)<>sizeof(long)
   then casting from size_t (which is unsigned) to long will never result
   in a value less than zero, resulting in an infinite loop. Three changes
   below.
New code: */
# if defined(__Ptr_Is_64) && !defined(__Int_Is_64)
typedef signed long signed_size_t;
# else
typedef signed int signed_size_t;
# endif
/* End new code */

#if defined(__mc68000)	/* much better on 68k */
void *memcpy(void *s1, const void *s2, size_t n)
{
    char *to=s1;
    const char *from=s2;
    int nn=n;
    /* [jonhsu] Thu Sep 24 17:22:52 PDT 1998
    Old code:
    while ((long)--nn >= 0)
    New code: */
    while ((signed_size_t)--nn >= 0)
    /* End new code */
	*to++ = *from++;
    return(s1);
}
#elif defined(__ppc)	/* slightly better on PowerPC */
void *memcpy(void *s1, const void *s2, size_t n)
{
    char *to=s1;

    /* [jonhsu] Thu Sep 24 17:22:52 PDT 1998
    Old code:
    while ((long)--n >= 0)
    New code: */
    while ((signed_size_t)--n >= 0)
    /* End new code */
	*((char *)to)++ = *((const char *)s2)++;

    return(s1);
}
#else			/* slightly better on V850 */
void *memcpy(void *s1, const void *s2, size_t n)
{
    char *result=s1;

    /* [jonhsu] Thu Sep 24 17:22:52 PDT 1998
    Old code:
    while ((long)--n >= 0)
    New code: */
    while ((signed_size_t)--n >= 0)
    /* End new code */
	*((char *)s1)++ = *((const char *)s2)++;

    return(result);
}
#endif

#endif /* defined(EMBEDDED) */
