/* wchar.h header for GHS */
#ifndef _WCHAR
#define _WCHAR
#include <stdio.h>
#include <limits.h>
#include <stddef.h>
#ifndef _YVALS
#include <yvals.h>
#endif
		/* MACROS */
/* [Duane] */
#if !defined(WEOF)
#define WEOF	((wint_t)(-1))
#endif
#define WCHAR_MIN	(-WCHAR_MAX - 1)

# define WCHAR_MAX (0 <= (wchar_t)(-1) ? (wchar_t) - 1 \
	: (wchar_t)((unsigned long)(wchar_t)(-1) >> 1))

		/* TYPE DEFINITIONS */
struct tm;
typedef int mbstate_t;

/* [Duane] Mon Sep 14 11:44:18 PDT 1998
 * Microsoft has the bad habbit of defining wint_t and wctype_t in
 * almost every header file imaginable. This code should keep Plauger 
 * and Microsoft from clashing.
 * New Code */

#if defined(_WIN32)

# if !defined(_WCTYPE_T_DEFINED)

#  define _WCTYPE_T_DEFINED		/* For Microsoft Header Files */

   typedef wchar_t wint_t;
   typedef wchar_t wctype_t;

# endif /* _WCTYPE_T_DEFINED */

/*
 * At this point, _WCTYPE_T_DEFINED is always true. We need to suppress
 * Plauger from duplicating wint_t below.
 */

# define _WINTT				/* For PJP Header Files       */

#endif /* _WIN32 */

/* End New Code */

#ifndef _WINTT
 #define _WINTT
typedef wchar_t wint_t;
#endif
		/* FUNCTIONS */
_C_LIB_DECL
#if defined(_WIN32)
/* fgetwc(), fputwc(), ungetwc() are defined in <stdio.h> on Windows. */
#elif defined(__ghs) && defined(__sun) && defined(__sysV4)
/* Solaris native */
wint_t fgetwc(_Filet *);
wint_t fputwc(wchar_t, _Filet *);
wint_t ungetwc(wint_t, _Filet *);
#elif defined(SUNOS)
/* SUNOS native */
wint_t fgetwc(FILE *);
wint_t fputwc(wchar_t, FILE *);
wint_t ungetwc(wint_t, FILE *);
#else	/* defined(__ghs) && defined(__sun) && defined(__sysV4) */
wint_t fgetwc(struct _Filet *);
wint_t fputwc(wchar_t, struct _Filet *);
wint_t ungetwc(wint_t, struct _Filet *);
#endif	/* defined(__ghs) && defined(__sun) && defined(__sysV4) */
wint_t btowc(int);
size_t mbrtowc(wchar_t *, const char *, size_t, mbstate_t *);
size_t wcslen(const wchar_t *);
size_t wcrtomb(char *, wchar_t, mbstate_t *);
int wctob(wint_t);
int wmemcmp(const wchar_t *, const wchar_t *, size_t);
wchar_t *wmemcpy(wchar_t *, const wchar_t *, size_t);
wchar_t *wmemmove(wchar_t *, const wchar_t *, size_t);
wchar_t *wmemset(wchar_t *, wchar_t, size_t);
_END_C_LIB_DECL
	/* inlines/macros */
#ifdef __cplusplus
		/* inlines and overloads, for C++ */
_C_LIB_DECL
const wchar_t *wmemchr(const wchar_t *, wchar_t, size_t);
_END_C_LIB_DECL
inline wchar_t *wmemchr(wchar_t *_S, wchar_t _C, size_t _N)
	{return ((wchar_t *)wmemchr((const wchar_t *)_S, _C, _N)); }
#else
wchar_t *wmemchr(const wchar_t *, wchar_t, size_t);
#endif /* __cplusplus */
#endif /* _WCHAR */

/*
 * Copyright (c) 1996 by P.J. Plauger.  ALL RIGHTS RESERVED. 
 * Consult your license regarding permissions and restrictions.
V2.1:0315 */
