/* wctype.h standard header */
#ifndef _WCTYPE
#define _WCTYPE
#include <stddef.h>
#ifndef _YVALS
#include <yvals.h>
#endif
		/* MACROS */
#ifndef WEOF
 #define WEOF	((wint_t)(-1))
#endif
		/* TYPE DEFINITIONS */
/* [Duane] Mon Sep 14 11:44:18 PDT 1998
 * Microsoft has the bad habbit of defining wint_t and wctype_t in
 * almost every header file imaginable. This code should keep Plauger 
 * and Microsoft from clashing.
 * New Code */

#if defined(_WIN32)

# if !defined(_WCTYPE_T_DEFINED)

#  define _WCTYPE_T_DEFINED		/* For Microsoft Header Files */

   typedef wchar_t wint_t;
   typedef wchar_t wctype_t;

# endif /* _WCTYPE_T_DEFINED */

/*
 * At this point, _WCTYPE_T_DEFINED is always true. We need to suppress
 * Plauger from duplicating wint_t below.
 */

# define _WINTT				/* For PJP Header Files       */

#endif /* _WIN32 */

/* End New Code */

typedef size_t wctrans_t;
/* [Duane] Mon Sep 14 11:44:18 PDT 1998
 * Keep from duplicating this definition.
 * New Code */
#ifndef _WCTYPE_T_DEFINED
#define _WCTYPE_T_DEFINED
typedef size_t wctype_t;
#endif
/* End New Code */
#ifndef _WINTT
 #define _WINTT
typedef wchar_t wint_t;
#endif
	/* ctype declarations */
_C_LIB_DECL
int iswctype(wint_t, wctype_t);
wint_t towctrans(wint_t, wctrans_t);
wctrans_t wctrans(const char *);
wctype_t wctype(const char *);
_END_C_LIB_DECL
#ifdef __cplusplus
		/* inlines, for C++ */
inline int iswalnum(wint_t _Wc)
	{return (iswctype(_Wc, 1)); }
inline int iswalpha(wint_t _Wc)
	{return (iswctype(_Wc, 2)); }
inline int iswcntrl(wint_t _Wc)
	{return (iswctype(_Wc, 3)); }
inline int iswdigit(wint_t _Wc)
	{return (iswctype(_Wc, 4)); }
inline int iswgraph(wint_t _Wc)
	{return (iswctype(_Wc, 5)); }
inline int iswlower(wint_t _Wc)
	{return (iswctype(_Wc, 6)); }
inline int iswprint(wint_t _Wc)
	{return (iswctype(_Wc, 7)); }
inline int iswpunct(wint_t _Wc)
	{return (iswctype(_Wc, 8)); }
inline int iswspace(wint_t _Wc)
	{return (iswctype(_Wc, 9)); }
inline int iswupper(wint_t _Wc)
	{return (iswctype(_Wc, 10)); }
inline int iswxdigit(wint_t _Wc)
	{return (iswctype(_Wc, 11)); }
inline wint_t towlower(wint_t _Wc)
	{return (towctrans(_Wc, 1)); }
inline wint_t towupper(wint_t _Wc)
	{return (towctrans(_Wc, 2)); }
#endif /* __cplusplus */
#endif /* _WCTYPE */

/*
 * Copyright (c) 1994 by P.J. Plauger.  ALL RIGHTS RESERVED. 
 * Consult your license regarding permissions and restrictions.
V2.1:0315 */
