/* xlocinfo.h internal header */
#ifndef _XLOCINFO
#define _XLOCINFO
#include <ctype.h>
#include <locale.h>
#include <wchar.h>
#ifndef _YVALS
#include <yvals.h>
#endif
		/* SUPPLEMENTAL CTYPE MACROS & DECLARATIONS */
#define _XA		0x200	/* extra alphabetic */
#define _XS		0x100	/* extra space */
#define _BB		0x80	/* BEL, BS, etc. */
#define _CN		0x40	/* CR, FF, HT, NL, VT */
#define _DI		0x20	/* '0'-'9' */
#define _LO		0x10	/* 'a'-'z' */
#define _PU		0x08	/* punctuation */
#define _SP		0x04	/* space */
#define _UP		0x02	/* 'A'-'Z' */
#define _XD		0x01	/* '0'-'9', 'A'-'F', 'a'-'f' */

		/* SUPPLEMENTAL LOCALE MACROS AND DECLARATIONS */
#define _X_ALL			LC_ALL
#define _X_COLLATE		0	/* or [0,] 1, 2, 3, etc. */
#define _X_CTYPE		1
#define _X_MONETARY	2
#define _X_NUMERIC		3
#define _X_TIME 		4
#define _X_MAX			4	/* highest real category */
#define _X_MESSAGE		5
#define _NCAT			(_X_MESSAGE + 1)	/* maximum + 1 */

#define _CATMASK(n)	(1 << (n))
#define _M_COLLATE	_CATMASK(_X_COLLATE)
#define _M_CTYPE	_CATMASK(_X_CTYPE)
#define _M_MONETARY	_CATMASK(_X_MONETARY)
#define _M_NUMERIC	_CATMASK(_X_NUMERIC)
#define _M_TIME		_CATMASK(_X_TIME)
#define _M_MESSAGE	_CATMASK(_X_MESSAGE)
#define _M_ALL		(_CATMASK(_NCAT) - 1)

#pragma ghs startdata

typedef struct _Collvec {
	int _Stuff;		/* as needed by _Strcoll, etc. */
	} _Collvec;

typedef struct _Ctypevec {
	int _Stuff;		/* as needed by _Tolower, etc. */
	const short *_Table;
	int _Delfl;
	} _Ctypevec;

typedef struct _Cvtvec {
	int _Stuff;		/* as needed by _Mbrtowc, etc. */
	} _Cvtvec;

		/* FUNCTION DECLARATIONS */
_C_LIB_DECL
_Collvec _Getcoll();
_Ctypevec _Getctype();
_Cvtvec _Getcvt();
char *_Getdays();
char *_Getmonths();
void *_Gettnames();
int _Mbrtowc(wchar_t *, const char *, size_t,
	mbstate_t *, const _Cvtvec *);
extern float _Stof(const char *, char **, long);
extern double _Stod(const char *, char **, long);
extern long double _Stold(const char *, char **, long);
int _Strcoll(const char *, const char *,
	const char *, const char *, const _Collvec *);
size_t _Strftime(char *, size_t, const char *,
	const struct tm *, void *);
size_t _Strxfrm(char *, char *,
	const char *, const char *, const _Collvec *);
int _Tolower(int, const _Ctypevec *);
int _Toupper(int, const _Ctypevec *);
int _Wcrtomb(char *, wchar_t, mbstate_t *, const _Cvtvec *);
int _Wcscoll(const wchar_t *, const wchar_t *,
	const wchar_t *, const wchar_t *, const _Collvec *);
size_t _Wcsxfrm(wchar_t *, wchar_t *,
	const wchar_t *, const wchar_t *, const _Collvec *);
_END_C_LIB_DECL
#pragma ghs enddata
#endif /* _XLOCINFO */

/*
 * Copyright (c) 1995 by P.J. Plauger.  ALL RIGHTS RESERVED. 
 * Consult your license regarding permissions and restrictions.
V2.1:0315 */
